ETSI STF525 / Internal Testing test suite This project provides an internal testing test suite and its associated Test Adapter/Codec

Functions
LibItsSecurity__Functions Namespace Reference

## Functions
OCTETSTRING | fx__hashWithSha256 (const OCTETSTRING &p__toBeHashedData)
OCTETSTRING | fx__hashWithSha384 (const OCTETSTRING &p__toBeHashedData)
OCTETSTRING | fx__signWithEcdsaNistp256WithSha256 (const OCTETSTRING &p__toBeSignedSecuredMessage, const OCTETSTRING &p__privateKey)
| Produces a Elliptic Curve Digital Signature Algorithm (ECDSA) signature. More...
OCTETSTRING | fx__signWithEcdsaBrainpoolp256WithSha256 (const OCTETSTRING &p__toBeSignedSecuredMessage, const OCTETSTRING &p__privateKey)
| Produces a Elliptic Curve Digital Signature Algorithm (ECDSA) signature. More...
OCTETSTRING | fx__signWithEcdsaBrainpoolp384WithSha384 (const OCTETSTRING &p__toBeSignedSecuredMessage, const OCTETSTRING &p__privateKey)
| Produces a Elliptic Curve Digital Signature Algorithm (ECDSA) signature. More...
BOOLEAN | fx__verifyWithEcdsaNistp256WithSha256 (const OCTETSTRING &p__toBeVerifiedData, const OCTETSTRING &p__signature, const OCTETSTRING &p__ecdsaNistp256PublicKeyX, const OCTETSTRING &p__ecdsaNistp256PublicKeyY)
| Verify the signature of the specified data. More...
BOOLEAN | fx__verifyWithEcdsaBrainpoolp256WithSha256 (const OCTETSTRING &p__toBeVerifiedData, const OCTETSTRING &p__signature, const OCTETSTRING &p__ecdsaBrainpoolp256PublicKeyX, const OCTETSTRING &p__ecdsaBrainpoolp256PublicKeyY)
| Verify the signature of the specified data. More...
BOOLEAN | fx__verifyWithEcdsaBrainpoolp384WithSha384 (const OCTETSTRING &p__toBeVerifiedData, const OCTETSTRING &p__signature, const OCTETSTRING &p__ecdsaBrainpoolp384PublicKeyX, const OCTETSTRING &p__ecdsaBrainpoolp384PublicKeyY)
| Verify the signature of the specified data. More...
OCTETSTRING | fx__test__hmac__sha256 (const OCTETSTRING &p__k, const OCTETSTRING &p__m)
| Generate a HMAC-SHA256 value based on the provided secret key. More...
OCTETSTRING | fx__test__encrypt__aes__128__ccm__test (const OCTETSTRING &p__k, const OCTETSTRING &p__n, const OCTETSTRING &p__pt)
| Encrypt the message using AES 128 CCM algorithm. More...
OCTETSTRING | fx__test__decrypt__aes__128__ccm__test (const OCTETSTRING &p__k, const OCTETSTRING &p__n, const OCTETSTRING &p__ct)
| Encrypt the message using AES 128 CCM algorithm. More...
OCTETSTRING | fx__encryptWithEciesNistp256WithSha256 (const OCTETSTRING &p__toBeEncryptedSecuredMessage, const OCTETSTRING &p__recipientsPublicKeyX, const OCTETSTRING &p__recipientsPublicKeyY, OCTETSTRING &p__publicEphemeralKeyX, OCTETSTRING &p__publicEphemeralKeyY, OCTETSTRING &p__encrypted__sym__key, OCTETSTRING &p__authentication__vector, OCTETSTRING &p__nonce)
| Encrypt the message using ECIES algprithm to encrypt AES 128 CCM symmetric key, as defined in IEEE Std 1609.2-2017. More...
OCTETSTRING | fx__decryptWithEciesNistp256WithSha256 (const OCTETSTRING &p__encryptedSecuredMessage, const OCTETSTRING &p__privateEncKey, const OCTETSTRING &p__publicEphemeralKeyX, const OCTETSTRING &p__publicEphemeralKeyY, const OCTETSTRING &p__encrypted__sym__key, const OCTETSTRING &p__authentication__vector, const OCTETSTRING &p__nonce)
OCTETSTRING | fx__encryptWithEciesBrainpoolp256WithSha256 (const OCTETSTRING &p__toBeEncryptedSecuredMessage, const OCTETSTRING &p__recipientsPublicKeyX, const OCTETSTRING &p__recipientsPublicKeyY, OCTETSTRING &p__publicEphemeralKeyX, OCTETSTRING &p__publicEphemeralKeyY, OCTETSTRING &p__encrypted__sym__key, OCTETSTRING &p__authentication__vector, OCTETSTRING &p__nonce)
OCTETSTRING | fx__decryptWithEciesBrainpoolp256WithSha256 (const OCTETSTRING &p__encryptedSecuredMessage, const OCTETSTRING &p__privateEncKey, const OCTETSTRING &p__publicEphemeralKeyX, const OCTETSTRING &p__publicEphemeralKeyY, const OCTETSTRING &p__encrypted__sym__key, const OCTETSTRING &p__authentication__vector, const OCTETSTRING &p__nonce)
BOOLEAN | fx__generateKeyPair__nistp256 (OCTETSTRING &p__privateKey, OCTETSTRING &p__publicKeyX, OCTETSTRING &p__publicKeyY)
| Produce a new public/private key pair based on Elliptic Curve Digital Signature Algorithm (ECDSA) algorithm. More...
BOOLEAN | fx__generateKeyPair__brainpoolp256 (OCTETSTRING &p__privateKey, OCTETSTRING &p__publicKeyX, OCTETSTRING &p__publicKeyY)
| Produce a new public/private key pair based on Elliptic Curve Digital Signature Algorithm (ECDSA) algorithm. More...
BOOLEAN | fx__generateKeyPair__brainpoolp384 (OCTETSTRING &p__privateKey, OCTETSTRING &p__publicKeyX, OCTETSTRING &p__publicKeyY)
| Produce a new public/private key pair based on Elliptic Curve Digital Signature Algorithm (ECDSA) algorithm. More...
BOOLEAN | fx__loadCertificates (const CHARSTRING &p__rootDirectory, const CHARSTRING &p__configId)
| Load in memory cache the certificates available in the specified directory. More...
BOOLEAN | fx__store__certificate (const CHARSTRING &p__cert__id, const OCTETSTRING &p__cert, const OCTETSTRING &p__private__key, const OCTETSTRING &p__public__key__x, const OCTETSTRING &p__public__key__y, const OCTETSTRING &p__hashid8, const OCTETSTRING &p__issuer, const OCTETSTRING_template &p__private__enc__key, const OCTETSTRING_template &p__public__enc__key__x, const OCTETSTRING_template &p__public__enc__key__y)
BOOLEAN | fx__unloadCertificates ()
| Unload from memory cache the certificates. More...
BOOLEAN | fx__readCertificate (const CHARSTRING &p__certificateId, OCTETSTRING &p__certificate)
| Read the specified certificate. More...
BOOLEAN | fx__readCertificateFromDigest (const OCTETSTRING &p__digest, CHARSTRING &p__certificateId)
BOOLEAN | fx__readCertificateDigest (const CHARSTRING &p__certificateId, OCTETSTRING &p__digest)
| Read the specified certificate digest. More...
BOOLEAN | fx__readSigningKey (const CHARSTRING &p__certificateId, OCTETSTRING &p__signingPrivateKey)
| Read the private keys for the specified certificate. More...
BOOLEAN | fx__readEncryptingKey (const CHARSTRING &p__certificateId, OCTETSTRING &p__encryptingPrivateKey)
| Read the private keys for the specified certificate. More...
BOOLEAN | fx__isValidPolygonalRegion (const IEEE1609dot2BaseTypes::PolygonalRegion &p__region)
BOOLEAN | fx__isPolygonalRegionInside (const IEEE1609dot2BaseTypes::PolygonalRegion &p__parent, const IEEE1609dot2BaseTypes::PolygonalRegion &p__region)
BOOLEAN | fx__isLocationInsideCircularRegion (const IEEE1609dot2BaseTypes::CircularRegion &p__region, const IEEE1609dot2BaseTypes::ThreeDLocation &p__location)
BOOLEAN | fx__isLocationInsideRectangularRegion (const IEEE1609dot2BaseTypes::SequenceOfRectangularRegion &p__region, const IEEE1609dot2BaseTypes::ThreeDLocation &p__location)
BOOLEAN | fx__isLocationInsidePolygonalRegion (const IEEE1609dot2BaseTypes::PolygonalRegion &p__region, const IEEE1609dot2BaseTypes::ThreeDLocation &p__location)
BOOLEAN | fx__isLocationInsideIdentifiedRegion (const IEEE1609dot2BaseTypes::IdentifiedRegion &p__region, const IEEE1609dot2BaseTypes::ThreeDLocation &p__location)
BOOLEAN | fx__isLocationInsideOtherRegion (const OCTETSTRING &p_region, const IEEE1609dot2BaseTypes::ThreeDLocation &p_location)
BOOLEAN | fx__areCirclesInside (const IEEE1609dot2BaseTypes::CircularRegion &p_circular_region_1, const IEEE1609dot2BaseTypes::CircularRegion &p_circular_region_2)
BOOLEAN | fx__areRectanglesInside (const IEEE1609dot2BaseTypes::SequenceOfRectangularRegion &p_rectanglar_region_1, const IEEE1609dot2BaseTypes::SequenceOfRectangularRegion &p_rectanglar_region_2)
BOOLEAN | fx__arePolygonsInside (const IEEE1609dot2BaseTypes::PolygonalRegion &p_polygonal_region_1, const IEEE1609dot2BaseTypes::PolygonalRegion &p_polygonal_region_2)
FLOAT | fx__dms2dd (const INTEGER &p__degrees, const INTEGER &p__minutes, const FLOAT &p__seconds, const OCTETSTRING &p__latlon)
| Convert a spacial coordinate from DMS to DMS. More...

## Function Documentation

## ◆ fx__areCirclesInside()

BOOLEAN LibItsSecurity__Functions::fx__areCirclesInside | ( | const IEEE1609dot2BaseTypes::CircularRegion & | p_circular_region_1,
|  | const IEEE1609dot2BaseTypes::CircularRegion & | p_circular_region_2
| ) |  |

## ◆ fx__arePolygonsInside()

BOOLEAN LibItsSecurity__Functions::fx__arePolygonsInside | ( | const IEEE1609dot2BaseTypes::PolygonalRegion & | p_polygonal_region_1,
|  | const IEEE1609dot2BaseTypes::PolygonalRegion & | p_polygonal_region_2
| ) |  |

## ◆ fx__areRectanglesInside()

BOOLEAN LibItsSecurity__Functions::fx__areRectanglesInside | ( | const IEEE1609dot2BaseTypes::SequenceOfRectangularRegion & | p_rectanglar_region_1,
|  | const IEEE1609dot2BaseTypes::SequenceOfRectangularRegion & | p_rectanglar_region_2
| ) |  |

## ◆ fx__decryptWithEciesBrainpoolp256WithSha256()

OCTETSTRING LibItsSecurity__Functions::fx__decryptWithEciesBrainpoolp256WithSha256 | ( | const OCTETSTRING & | p__encryptedSecuredMessage,
|  | const OCTETSTRING & | p__privateEncKey,
|  | const OCTETSTRING & | p__publicEphemeralKeyX,
|  | const OCTETSTRING & | p__publicEphemeralKeyY,
|  | const OCTETSTRING & | p__encrypted__sym__key,
|  | const OCTETSTRING & | p__authentication__vector,
|  | const OCTETSTRING & | p__nonce
| ) |  |

## ◆ fx__decryptWithEciesNistp256WithSha256()

OCTETSTRING LibItsSecurity__Functions::fx__decryptWithEciesNistp256WithSha256 | ( | const OCTETSTRING & | p__encryptedSecuredMessage,
|  | const OCTETSTRING & | p__privateEncKey,
|  | const OCTETSTRING & | p__publicEphemeralKeyX,
|  | const OCTETSTRING & | p__publicEphemeralKeyY,
|  | const OCTETSTRING & | p__encrypted__sym__key,
|  | const OCTETSTRING & | p__authentication__vector,
|  | const OCTETSTRING & | p__nonce
| ) |  |

## ◆ fx__dms2dd()

FLOAT LibItsSecurity__Functions::fx__dms2dd | ( | const INTEGER & | p__degrees,
|  | const INTEGER & | p__minutes,
|  | const FLOAT & | p__seconds,
|  | const OCTETSTRING & | p__latlon
| ) |  |

Convert a spacial coordinate from DMS to DMS.

Parameters

  p_degrees | The degrees (D)
  p_minutes | The minutes (M)
  p_seconds | The seconds (S)
  p_latlon | The latitude/longitude: (N|S|E|W)

Returns
  The decimal coordinate on success, 0.0, otherwise Unchanged fx_dms2dd(in Int p_degrees, in Int p_minutes, in float p_seconds, in Oct1 p_latlon) return float;

## ◆ fx__encryptWithEciesBrainpoolp256WithSha256()

OCTETSTRING LibItsSecurity__Functions::fx__encryptWithEciesBrainpoolp256WithSha256 | ( | const OCTETSTRING & | p__toBeEncryptedSecuredMessage,
|  | const OCTETSTRING & | p__recipientsPublicKeyX,
|  | const OCTETSTRING & | p__recipientsPublicKeyY,
|  | OCTETSTRING & | p__publicEphemeralKeyX,
|  | OCTETSTRING & | p__publicEphemeralKeyY,
|  | OCTETSTRING & | p__encrypted__sym__key,
|  | OCTETSTRING & | p__authentication__vector,
|  | OCTETSTRING & | p__nonce
| ) |  |

## ◆ fx__encryptWithEciesNistp256WithSha256()

OCTETSTRING LibItsSecurity__Functions::fx__encryptWithEciesNistp256WithSha256 | ( | const OCTETSTRING & | p__toBeEncryptedSecuredMessage,
|  | const OCTETSTRING & | p__recipientsPublicKeyX,
|  | const OCTETSTRING & | p__recipientsPublicKeyY,
|  | OCTETSTRING & | p__publicEphemeralKeyX,
|  | OCTETSTRING & | p__publicEphemeralKeyY,
|  | OCTETSTRING & | p__encrypted__sym__key,
|  | OCTETSTRING & | p__authentication__vector,
|  | OCTETSTRING & | p__nonce
| ) |  |

Encrypt the message using ECIES algprithm to encrypt AES 128 CCM symmetric key, as defined in IEEE Std 1609.2-2017.

Parameters

  [in] | p__k | The symmetric encryption key
  [in] | p__n | The initial vector, nonce vector
  [in] | pp__ct__pt | The encrypted message concatenated to the AES 128 CCM tag

Returns
  The original message

See also
  IEEE Std 1609.2-2017 Clause 5.3.5 Public key encryption algorithms: ECIES
  https://www.nominet.uk/researchblog/how-elliptic-curve-cryptography-encryption-works/
  http://digital.csic.es/bitstream/10261/32671/1/V2-I2-P7-13.pdf

## ◆ fx__generateKeyPair__brainpoolp256()

BOOLEAN LibItsSecurity__Functions::fx__generateKeyPair__brainpoolp256 | ( | OCTETSTRING & | p__privateKey,
|  | OCTETSTRING & | p__publicKeyX,
|  | OCTETSTRING & | p__publicKeyY
| ) |  |

Produce a new public/private key pair based on Elliptic Curve Digital Signature Algorithm (ECDSA) algorithm.

This function should not be used by the ATS

Parameters

  p_privateKey | The new private key value
  p_publicKeyX | The new public key value (x coordinate)
  p_publicKeyX | The new public key value (y coordinate)

Returns
  true on success, false otherwise fx_generateKeyPair_nistp256(out octetstring<UInt64> p_privateKey, out octetstring p_publicKeyX, out octetstring p_publicKeyY) return boolean;

## ◆ fx__generateKeyPair__brainpoolp384()

BOOLEAN LibItsSecurity__Functions::fx__generateKeyPair__brainpoolp384 | ( | OCTETSTRING & | p__privateKey,
|  | OCTETSTRING & | p__publicKeyX,
|  | OCTETSTRING & | p__publicKeyY
| ) |  |

Produce a new public/private key pair based on Elliptic Curve Digital Signature Algorithm (ECDSA) algorithm.

This function should not be used by the ATS

Parameters

  p_privateKey | The new private key value
  p_publicKeyX | The new public key value (x coordinate)
  p_publicKeyX | The new public key value (y coordinate)

Returns
  true on success, false otherwise fx_generateKeyPair_nistp256(out octetstring<UInt64> p_privateKey, out octetstring p_publicKeyX, out octetstring p_publicKeyY) return boolean;

## ◆ fx__generateKeyPair__nistp256()

BOOLEAN LibItsSecurity__Functions::fx__generateKeyPair__nistp256 | ( | OCTETSTRING & | p__privateKey,
|  | OCTETSTRING & | p__publicKeyX,
|  | OCTETSTRING & | p__publicKeyY
| ) |  |

Produce a new public/private key pair based on Elliptic Curve Digital Signature Algorithm (ECDSA) algorithm.

This function should not be used by the ATS

Parameters

  p_privateKey | The new private key value
  p_publicKeyX | The new public key value (x coordinate)
  p_publicKeyX | The new public key value (y coordinate)

Returns
  true on success, false otherwise fx_generateKeyPair_nistp256(out octetstring<UInt64> p_privateKey, out octetstring p_publicKeyX, out octetstring p_publicKeyY) return boolean;

## ◆ fx__hashWithSha256()

OCTETSTRING LibItsSecurity__Functions::fx__hashWithSha256 | ( | const OCTETSTRING & | p__toBeHashedData | ) |

## ◆ fx__hashWithSha384()

OCTETSTRING LibItsSecurity__Functions::fx__hashWithSha384 | ( | const OCTETSTRING & | p__toBeHashedData | ) |

## ◆ fx__isLocationInsideCircularRegion()

BOOLEAN LibItsSecurity__Functions::fx__isLocationInsideCircularRegion | ( | const IEEE1609dot2BaseTypes::CircularRegion & | p__region,
|  | const IEEE1609dot2BaseTypes::ThreeDLocation & | p__location
| ) |  |

## ◆ fx__isLocationInsideIdentifiedRegion()

BOOLEAN LibItsSecurity__Functions::fx__isLocationInsideIdentifiedRegion | ( | const IEEE1609dot2BaseTypes::IdentifiedRegion & | p__region,
|  | const IEEE1609dot2BaseTypes::ThreeDLocation & | p__location
| ) |  |

## ◆ fx__isLocationInsideOtherRegion()

BOOLEAN LibItsSecurity__Functions::fx__isLocationInsideOtherRegion | ( | const OCTETSTRING & | p_region,
|  | const IEEE1609dot2BaseTypes::ThreeDLocation & | p_location
| ) |  |

## ◆ fx__isLocationInsidePolygonalRegion()

BOOLEAN LibItsSecurity__Functions::fx__isLocationInsidePolygonalRegion | ( | const IEEE1609dot2BaseTypes::PolygonalRegion & | p__region,
|  | const IEEE1609dot2BaseTypes::ThreeDLocation & | p__location
| ) |  |

## ◆ fx__isLocationInsideRectangularRegion()

BOOLEAN LibItsSecurity__Functions::fx__isLocationInsideRectangularRegion | ( | const IEEE1609dot2BaseTypes::SequenceOfRectangularRegion & | p__region,
|  | const IEEE1609dot2BaseTypes::ThreeDLocation & | p__location
| ) |  |

## ◆ fx__isPolygonalRegionInside()

BOOLEAN LibItsSecurity__Functions::fx__isPolygonalRegionInside | ( | const IEEE1609dot2BaseTypes::PolygonalRegion & | p__parent,
|  | const IEEE1609dot2BaseTypes::PolygonalRegion & | p__region
| ) |  |

## ◆ fx__isValidPolygonalRegion()

BOOLEAN LibItsSecurity__Functions::fx__isValidPolygonalRegion | ( | const IEEE1609dot2BaseTypes::PolygonalRegion & | p__region | ) |

## ◆ fx__loadCertificates()

BOOLEAN LibItsSecurity__Functions::fx__loadCertificates | ( | const CHARSTRING & | p__rootDirectory,
|  | const CHARSTRING & | p__configId
| ) |  |

Load in memory cache the certificates available in the specified directory.

Parameters

  p_rootDirectory | Root directory to access to the certificates identified by the certificate ID
  p_configId | A configuration identifier

Remarks
  This method SHALL be call before any usage of certificates

Returns
  true on success, false otherwise fx_loadCertificates(in charstring p_rootDirectory, in charstring p_configId) return boolean;

## ◆ fx__readCertificate()

BOOLEAN LibItsSecurity__Functions::fx__readCertificate | ( | const CHARSTRING & | p__certificateId,
|  | OCTETSTRING & | p__certificate
| ) |  |

Read the specified certificate.

Parameters

  p_certificateId | the certificate identifier
  p_certificate | the expected certificate

Returns
  true on success, false otherwise

## ◆ fx__readCertificateDigest()

BOOLEAN LibItsSecurity__Functions::fx__readCertificateDigest | ( | const CHARSTRING & | p__certificateId,
|  | OCTETSTRING & | p__digest
| ) |  |

Read the specified certificate digest.

Parameters

  p_certificateId | the certificate identifier
  p_digest | the expected certificate

Returns
  true on success, false otherwise

## ◆ fx__readCertificateFromDigest()

BOOLEAN LibItsSecurity__Functions::fx__readCertificateFromDigest | ( | const OCTETSTRING & | p__digest,
|  | CHARSTRING & | p__certificateId
| ) |  |

## ◆ fx__readEncryptingKey()

BOOLEAN LibItsSecurity__Functions::fx__readEncryptingKey | ( | const CHARSTRING & | p__certificateId,
|  | OCTETSTRING & | p__encryptingPrivateKey
| ) |  |

Read the private keys for the specified certificate.

Parameters

  p_keysId | the keys identifier
  p_encryptPrivateKey | the encrypt private key

Returns
  true on success, false otherwise fx_readEncryptingKey(in charstring p_keysId, out Oct32 p_encryptingPrivateKey) return boolean;

## ◆ fx__readSigningKey()

BOOLEAN LibItsSecurity__Functions::fx__readSigningKey | ( | const CHARSTRING & | p__certificateId,
|  | OCTETSTRING & | p__signingPrivateKey
| ) |  |

Read the private keys for the specified certificate.

Parameters

  p_certificateId | the keys identifier
  p_signingPrivateKey | the signing private key

Returns
  true on success, false otherwise

## ◆ fx__signWithEcdsaBrainpoolp256WithSha256()

OCTETSTRING LibItsSecurity__Functions::fx__signWithEcdsaBrainpoolp256WithSha256 | ( | const OCTETSTRING & | p__toBeSignedSecuredMessage,
|  | const OCTETSTRING & | p__privateKey
| ) |  |

Produces a Elliptic Curve Digital Signature Algorithm (ECDSA) signature.

Parameters

  [in] | p__toBeSignedSecuredMessage | The data to be signed
  [in] | p__privateKey | The private key

Returns
  The signature value

## ◆ fx__signWithEcdsaBrainpoolp384WithSha384()

OCTETSTRING LibItsSecurity__Functions::fx__signWithEcdsaBrainpoolp384WithSha384 | ( | const OCTETSTRING & | p__toBeSignedSecuredMessage,
|  | const OCTETSTRING & | p__privateKey
| ) |  |

Produces a Elliptic Curve Digital Signature Algorithm (ECDSA) signature.

Parameters

  [in] | p__toBeSignedSecuredMessage | The data to be signed
  [in] | p__privateKey | The private key

Returns
  The signature value

## ◆ fx__signWithEcdsaNistp256WithSha256()

OCTETSTRING LibItsSecurity__Functions::fx__signWithEcdsaNistp256WithSha256 | ( | const OCTETSTRING & | p__toBeSignedSecuredMessage,
|  | const OCTETSTRING & | p__privateKey
| ) |  |

Produces a Elliptic Curve Digital Signature Algorithm (ECDSA) signature.

Parameters

  [in] | p__toBeSignedSecuredMessage | The data to be signed
  [in] | p__privateKey | The private key

Returns
  The signature value

## ◆ fx__store__certificate()

BOOLEAN LibItsSecurity__Functions::fx__store__certificate | ( | const CHARSTRING & | p__cert__id,
|  | const OCTETSTRING & | p__cert,
|  | const OCTETSTRING & | p__private__key,
|  | const OCTETSTRING & | p__public__key__x,
|  | const OCTETSTRING & | p__public__key__y,
|  | const OCTETSTRING & | p__hashid8,
|  | const OCTETSTRING & | p__issuer,
|  | const OCTETSTRING_template & | p__private__enc__key,
|  | const OCTETSTRING_template & | p__public__enc__key__x,
|  | const OCTETSTRING_template & | p__public__enc__key__y
| ) |  |

## ◆ fx__test__decrypt__aes__128__ccm__test()

OCTETSTRING LibItsSecurity__Functions::fx__test__decrypt__aes__128__ccm__test | ( | const OCTETSTRING & | p__k,
|  | const OCTETSTRING & | p__n,
|  | const OCTETSTRING & | p__pt
| ) |  |

Encrypt the message using AES 128 CCM algorithm.

Parameters

  [in] | p__k | The symmetric encryption key
  [in] | p__n | The initial vector, nonce vector
  [in] | pp__ct__pt | The encrypted message concatenated to the AES 128 CCM tag

Returns
  The original message

## ◆ fx__test__encrypt__aes__128__ccm__test()

OCTETSTRING LibItsSecurity__Functions::fx__test__encrypt__aes__128__ccm__test | ( | const OCTETSTRING & | p__k,
|  | const OCTETSTRING & | p__n,
|  | const OCTETSTRING & | p__pt
| ) |  |

Encrypt the message using AES 128 CCM algorithm.

Parameters

  [in] | p__k | The symmetric encryption key
  [in] | p__n | The initial vector, nonce vector
  [in] | p__pt | The message to encrypt

Returns
  The encrypted message concatenated to the AES 128 CCM tag

## ◆ fx__test__hmac__sha256()

OCTETSTRING LibItsSecurity__Functions::fx__test__hmac__sha256 | ( | const OCTETSTRING & | p__k,
|  | const OCTETSTRING & | p__m
| ) |  |

Generate a HMAC-SHA256 value based on the provided secret key.

Parameters

  [in] | p__k | The secret key used for the HMAC calculation
  [in] | p__m | The message

Returns
  The HMAC value resized to 16-byte

## ◆ fx__unloadCertificates()

BOOLEAN LibItsSecurity__Functions::fx__unloadCertificates | ( |  | ) |

Unload from memory cache the certificates.

Returns
  true on success, false otherwise

## ◆ fx__verifyWithEcdsaBrainpoolp256WithSha256()

BOOLEAN LibItsSecurity__Functions::fx__verifyWithEcdsaBrainpoolp256WithSha256 | ( | const OCTETSTRING & | p__toBeVerifiedData,
|  | const OCTETSTRING & | p__signature,
|  | const OCTETSTRING & | p__ecdsaBrainpoolp256PublicKeyX,
|  | const OCTETSTRING & | p__ecdsaBrainpoolp256PublicKeyY
| ) |  |

Verify the signature of the specified data.

Parameters

  [in] | p__toBeVerifiedData | The data to be verified
  [in] | p__signature | The signature
  [in] | p__ecdsaBrainpoolp256PublicKeyX | The public key (x coordinate)
  [in] | p__ecdsaBrainpoolp256PublicKeyY | The public key (y coordinate)

Returns
  true on success, false otherwise

## ◆ fx__verifyWithEcdsaBrainpoolp384WithSha384()

BOOLEAN LibItsSecurity__Functions::fx__verifyWithEcdsaBrainpoolp384WithSha384 | ( | const OCTETSTRING & | p__toBeVerifiedData,
|  | const OCTETSTRING & | p__signature,
|  | const OCTETSTRING & | p__ecdsaBrainpoolp384PublicKeyX,
|  | const OCTETSTRING & | p__ecdsaBrainpoolp384PublicKeyY
| ) |  |

Verify the signature of the specified data.

Parameters

  [in] | p__toBeVerifiedData | The data to be verified
  [in] | p__signature | The signature
  [in] | p__ecdsaBrainpoolp384PublicKeyX | The public key (x coordinate)
  [in] | p__ecdsaBrainpoolp384PublicKeyY | The public key (y coordinate)

Returns
  true on success, false otherwise

## ◆ fx__verifyWithEcdsaNistp256WithSha256()

BOOLEAN LibItsSecurity__Functions::fx__verifyWithEcdsaNistp256WithSha256 | ( | const OCTETSTRING & | p__toBeVerifiedData,
|  | const OCTETSTRING & | p__signature,
|  | const OCTETSTRING & | p__ecdsaNistp256PublicKeyX,
|  | const OCTETSTRING & | p__ecdsaNistp256PublicKeyY
| ) |  |

Verify the signature of the specified data.

Parameters

  [in] | p__toBeVerifiedData | The data to be verified
  [in] | p__signature | The signature
  [in] | p__ecdsaNistp256PublicKeyX | The public key (x coordinate)
  [in] | p__ecdsaNistp256PublicKeyY | The public key (y coordinate)

Returns
  true on success, false otherwise